﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PurchOrder.Forms
{
  public partial class PurchOrderListSelect : ChildWindow
  {
    public string Where { get; set; }

    public PurchOrderListSelect()
    {
      InitializeComponent();

      Where = "";

      List<SelectWindowRow> sl = new List<SelectWindowRow>();

      sl.Add(new SelectWindowRow("ORDER_NO", "Bestellnr."));
      sl.Add(new SelectWindowRow("VENDOR_NO", "Lieferantennr."));
      sl.Add(new SelectWindowRow("ifsapp.Supplier_API.Get_Vendor_name(VENDOR_NO)", "Lieferantenname"));
      sl.Add(new SelectWindowRow("CONTRACT", "Standort"));

      dg.ItemsSource = sl;
    }

    private void OKButton_Click(object sender, RoutedEventArgs e)
    {
      string lineWhere = "";

      dg.ExitEditMode(false);

      List<SelectWindowRow> sl = (List<SelectWindowRow>)dg.ItemsSource;

      foreach (SelectWindowRow line in sl)
      {
        string[] valueList = line.Value.Trim().Split(new char[] { ';' });
        lineWhere = "";

        foreach (string v in valueList)
        {
          string value = v.Trim();
          string comparationOperator = line.ComparativeOperator;

          if (value.Length > 0)
          {
            if (value.IndexOf("%") >= 0)
            {
              comparationOperator = "LIKE";
            }

            if (value.StartsWith(">="))
            {
              comparationOperator = ">=";
              value = value.Substring(2);
            }

            if (value.StartsWith("<="))
            {
              comparationOperator = "<=";
              value = value.Substring(2);
            }

            if (value.StartsWith(">"))
            {
              comparationOperator = ">";
              value = value.Substring(1);
            }

            if (value.StartsWith("<"))
            {
              comparationOperator = "<";
              value = value.Substring(1);
            }

            if (value.StartsWith("="))
            {
              comparationOperator = "=";
              value = value.Substring(1);
            }

            value = value.Trim();

            if (value.Length > 0)
            {
              if (lineWhere.Length > 0)
              {
                lineWhere += " OR ";
              }

              lineWhere += line.DatabaseName + " " + comparationOperator + " " + "'" + value + "'";

            }
          }
        }

        if (lineWhere.Length > 0)
        {
          if (Where.Length > 0)
          {
            Where += " AND ";
          }

          Where += "(" + lineWhere + ")";
        }
      }

      this.DialogResult = true;
    }

    private void CancelButton_Click(object sender, RoutedEventArgs e)
    {
      this.DialogResult = false;
      Where = String.Empty;
    }

    private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
    {
      
//      dg.Rows[0].Cells[1].IsActive = true;
      dg.Focus();
    }

  }
}

